;MI - C  C8051 v-5x211  (C) COPYRIGHT  G. KERSTING / H. ROSE, 1986     

	CSEG
;	EXTRN   spxl:BYTE,spxh:BYTE
;
;LAUFZEITSYSTEM - FUNKTIONENTRACE
;
	ENTRY CFTRCZ
	EXT CCTRODEC
	EXT CCTASTEIN
	EXT CCTRTEXT
	EXT CCTRCCO
	EXT CCTRCV
	EXT cfprim:byte
	EXT CFNEG
	ext	ccpush,ccpop
	ext	clpush,clpop

expo	equ	7

CFTROUT:
	clr	a
	movc	a,@a+dptr
	inc	dptr
	JNZ	CFTROUT
	RET

CFTRCZ:
	pop	dph
	pop	dpl
	push	ar3
	push	ar2
	push	ar1
	push	ar0

	push	dpl
	push	dph

	CALL	CCTASTEIN

	mov	dptr,#CCTRCV
	movx	a,@dptr
	pop	dph
	pop	dpl
	inc	a
	JZ	CFTRC3

	LCALL	CFTROUT
	pop	ar0
	pop	ar1
	pop	ar2
	pop	ar3
	clr	a
	jmp	@a+dptr

	RET

CFTRC3:
	CALL	CCTRTEXT

CFTRC4:
	pop	ar0
	pop	ar1
	pop	ar2
	pop	ar3
	push	dpl 	
	push	dph

	call	clpush
	mov	r1,#cfprim+expo
	mov	a,@r1
	dec	r1
	JNZ	CRTRA1
	mov	A,#'0'
	CALL	CCTRCCO
	SJMP	CRTRA2
CRTRA1:
	mov	a,@r1
	anl	a,#0f0h
	mov	r2,a
	JZ	CRTRA3
	call	clpush
	mov	A,#'-'
	CALL	CCTRCCO
	CALL	CFNEG
	call	clpop
CRTRA3:
	call	clpush
	mov	A,#'0'
	CALL	CCTRCCO
	mov	A,#'.'
	CALL	CCTRCCO
	call	clpop
	call	clpush
	mov	a,@r1
	add	a,#'0'
	CALL	CCTRCCO
	call	clpop
	mov	r3,#6

CRTRA4:
	dec	r1
	call	clpush
	mov	a,@r1
	RR	a
	RR	a
	RR	a
	RR	a
	anl	a,#0fh
	add	a,#'0'
	CALL	CCTRCCO
	call	clpop
	call	clpush
	mov	a,@r1
	anl	a,#0fh
	add	a,#'0'
	CALL	CCTRCCO
	call	clpop
	djnz	r3,CRTRA4

	call	clpush
	mov	a,#'E'
	CALL	CCTRCCO
	mov	a,cfprim+expo
	add	a,#80h
	mov	r0,a
	mov	a,#0ffh
	addc	a,#0
	mov	r1,a
	call	ccpush
	CALL	CCTRODEC
	call	ccpop
	call	clpop
	mov	a,r2
	JZ	CRTRA2
	CALL	CFNEG

CRTRA2:
	call	clpop
CFTRC7:
	RET

	DSEG

	TITLE	CFWANTOD.ASM

 ENTRY	CUTOD,CUSTOD,CCTOD,CCSTOD
 ENTRY	CLTOD,CLSTOD
 ext	cfneg,cfsneg
 EXT	ccneg,cudiv,cfswap
 EXT	clneg,cldiv
 EXT	cfprim:BYTE
 EXT	clres :BYTE

VORZEI	EQU	6
st1	equ	6
st23	equ	5
st45	equ	4
st67	equ	3
st89	equ	2
stab	equ	1
EXPO	EQU	7
NMANT	EQU	7	

CUSTOD:
	lcall	cfswap	
	lcall	cutod
	ljmp	cfswap	

CUTOD:
	lcall	cwdnul
	mov	a,r0
	orl	a,r1
	jnz	cwud
	ret

CCTOD:
	lcall	cwdnul
	mov	a,r0
	orl	a,r1
	jz	cwid2
	mov	a,r1
	push	acc
	jnb	0e7h,cwid1	
	lcall	ccneg
cwid1:
	lcall	cwud
	pop	acc
	jnb	0e7h,cwid2	
	lcall	cfneg
cwid2:
	ret

CCSTOD:
	lcall	cfswap	
	lcall	cctod
	ljmp	cfswap	

cwdnul:
	push	ar0
	push	ar1
	mov	r0,#8
	mov	r1,#cfprim+expo
	clr	a
cwdnu0:
	mov	@r1,a
	dec	r1
	djnz	r0,cwdnu0
	pop	ar1
	pop	ar0
	ret

cwud:
	push	ar4
	push	ar5
	mov	r4,ar0
	mov	r5,ar1
	mov	r0,#10h
	mov	r1,#27h
	lcall	cudiv

	lcall	cwudx
	mov	r0,#0e8h
	mov	r1,#03h
	lcall	cudiv

	lcall	cwudx
	mov	r0,#64h
	mov	r1,#0h
	lcall	cudiv

	lcall	cwudx
	mov	r0,#0ah
	mov	r1,#0h
	lcall	cudiv

	lcall	cwudx
	mov	r0,ar4
	lcall	cwudx

	mov	a,cfprim+expo	
	add	a,#80h
	mov	cfprim+expo,a	

	pop	ar5
	pop	ar4
	ret

cwudx:
	mov	a,cfprim+expo	
	orl	a,r0
	jz	cwudx0

	inc	cfprim+expo	
	mov	a,cfprim+expo
	rrc	a

	mov	r1,#cfprim+vorzei
	jc	cwudx1

	xch	a,r1
	subb	a,r1
	mov	r1,a
	mov	a,r0
	swap	a
	mov	@r1,a
cwudx0:
	ret

cwudx1:
	clr	c
	xch	a,r1
	subb	a,r1
	mov	r1,a
	mov	a,r0
	xchd	a,@r1
	ret

CLTOD:
	lcall	cwdnul
	mov	a,r0
	orl	a,r1
	orl	a,r2
	orl	a,r3
	jz	cltd2
	mov	a,r3
	push	acc
	jnb	0e7h,cltd1	
	lcall	clneg
cltd1:
	lcall	clpd
	pop	acc
	jnb	0e7h,cltd2	
	lcall	cfneg
cltd2:
	ret

CLSTOD:
	lcall	cfswap	
	lcall	cltod
	ljmp	cfswap	

clpd:
	mov	clres+0,r4	
	mov	clres+1,r5
	mov	clres+2,r6
	mov	clres+3,r7

	mov	r4,ar0
	mov	r5,ar1
	mov	r6,ar2
	mov	r7,ar3

	mov	r0,#000h
	mov	r1,#0cah
	mov	r2,#09ah
	mov	r3,#03bh	
	lcall	cldiv

	lcall	cwudx

	mov	r0,#00h
	mov	r1,#0e1h
	mov	r2,#0f5h
	mov	r3,#005h	
	lcall	cldiv

	lcall	cwudx

	mov	r0,#080h
	mov	r1,#096h
	mov	r2,#098h
	mov	r3,#000h	
	lcall	cldiv

	lcall	cwudx

	mov	r0,#040h
	mov	r1,#042h
	mov	r2,#00fh
	mov	r3,#000h	
	lcall	cldiv

	lcall	cwudx

	mov	r0,#0a0h
	mov	r1,#086h
	mov	r2,#001h
	mov	r3,#000h	

	lcall	cldiv

	lcall	cwudx

	mov	r0,#010h
	mov	r1,#027h
	mov	r2,#000h
	mov	r3,#000h	

	lcall	cldiv

	lcall	cwudx

	mov	r0,#0e8h
	mov	r1,#003h
	mov	r2,#000h
	mov	r3,#000h	

	lcall	cldiv

	lcall	cwudx

	mov	r0,#064h
	mov	r1,#000h
	mov	r2,#000h
	mov	r3,#000h	

	lcall	cldiv

	lcall	cwudx

	mov	r0,#0ah
	mov	r1,#00h
	mov	r2,#00h
	mov	r3,#00h

	lcall	cldiv

	lcall	cwudx

	mov	r0,ar4
	lcall	cwudx

	mov	a,cfprim+expo	
	add	a,#80h
	mov	cfprim+expo,a	

	mov	r4,clres+0	
	mov	r5,clres+1
	mov	r6,clres+2
	mov	r7,clres+3

	ret

	TITLE	CFWAND.ASM

 ENTRY	CFTOI,CFSTOI,CFTOL,CFSTOL
 EXT	ccneg,cfswap
 EXT	clneg,cfneg
 EXT	cfprim:BYTE

VORZEI	EQU	6
st1	equ	6
st23	equ	5
st45	equ	4
st67	equ	3
st89	equ	2
stab	equ	1
EXPO	EQU	7
NMANT	EQU	7	

CFSTOI:
	lcall	cfswap	
	lcall	cftoi
	ljmp	cfswap	

CFTOI:
	mov	a,cfprim+expo	
	clr	c
	subb	a,#81h
	jnc	cftoi0

	mov	r0,#0
	mov	r1,#0
	ret

cftoi0:
	mov	a,cfprim+expo	
	subb	a,#86h
	jc	cftoi2

	mov	a,cfprim+vorzei	
	jnb	0E7H,cftoi1	
	mov	r0,#0
	mov	r1,#80h
	ret

cftoi1:
	mov	r0,#0ffh
	mov	r1,#07fh	
	ret

cftoi2:
	mov	a,cfprim+vorzei	
	jnb	0E7H,cftoi3	
	lcall	cfneg
	lcall	cftoi3
	ljmp	ccneg

cftoi3:	clr	a
	mov	r0,a
	mov	r1,a

	mov	a,cfprim+vorzei	
	lcall	cftoia
	mov	a,cfprim+expo
	cjne	a,#81h,cftoi4	
	ret

cftoi4:	lcall	cftoix
	mov	a,cfprim+st23	
	swap	a
	lcall	cftoia
	mov	a,cfprim+expo
	cjne	a,#82h,cftoi5	
	ret

cftoi5:	lcall	cftoix
	mov	a,cfprim+st23	
	lcall	cftoia
	mov	a,cfprim+expo
	cjne	a,#83h,cftoi6	
	ret

cftoi6:	lcall	cftoix
	mov	a,cfprim+st45	
	swap	a
	lcall	cftoia
	mov	a,cfprim+expo
	cjne	a,#84h,cftoi7	
	ret

cftoi7:	lcall	cftoix
	jc	cftoi1

	mov	a,cfprim+st45	
	lcall	cftoia
	jc	cftoi1

	ret

cftoia:
	anl	a,#0fh
	add	a,r0
	mov	r0,a
	clr	a
	addc	a,r1
	mov	r1,a
	ret

cftoix:
	mov	b,#10
	mov	a,r0
	mul	ab
	mov	r0,a
	mov	a,b
	xch	a,r1
	mov	b,#10
	mul	ab
	jnb	0D2H,cftix1	
	setb	c
	ret

cftix1:	add	a,r1
	mov	r1,a
	ret


CFSTOL:
	lcall	cfswap	
	lcall	cftol
	ljmp	cfswap	

CFTOL:
	mov	a,cfprim+expo	
	clr	c
	subb	a,#81h
	jnc	cftol0

	clr	a
	mov	r0,a
	mov	r1,a
	mov	r2,a
	mov	r3,a
	ret

cftol0:
	mov	a,cfprim+expo	
	subb	a,#8bh
	jc	cftol2

	mov	a,cfprim+vorzei	
	jnb	0E7H,cftol1	
	clr	a
	mov	r0,a
	mov	r1,a
	mov	r2,a
	mov	r3,#80h
	ret

cftol1:
	mov	a,#0ffh
	mov	r0,a
	mov	r1,a
	mov	r2,a
	mov	r3,#07fh	
	ret
cftol2:
	mov	a,cfprim+vorzei	
	jnb	0E7H,cftol3	
	lcall	cfneg
	lcall	cftol3
	ljmp	clneg

cftol3:	clr	a
	mov	r0,a
	mov	r1,a
	mov	r2,a
	mov	r3,a

	mov	a,cfprim+vorzei	
	lcall	cftola
	mov	a,cfprim+expo
	cjne	a,#81h,cftol4	
	ret

cftol4:	lcall	cftolx
	mov	a,cfprim+st23	
	swap	a
	lcall	cftola
	mov	a,cfprim+expo
	cjne	a,#82h,cftol5	
	ret

cftol5:	lcall	cftolx
	mov	a,cfprim+st23	
	lcall	cftola
	mov	a,cfprim+expo
	cjne	a,#83h,cftol6	
	ret

cftol6:	lcall	cftolx
	mov	a,cfprim+st45	
	swap	a
	lcall	cftola
	mov	a,cfprim+expo
	cjne	a,#84h,cftol7	
	ret

cftol7:	lcall	cftolx
	mov	a,cfprim+st45	
	lcall	cftola
	mov	a,cfprim+expo
	cjne	a,#85h,cftol8	
	ret

cftol8:	lcall	cftolx
	mov	a,cfprim+st67	
	swap	a
	lcall	cftola
	mov	a,cfprim+expo
	cjne	a,#86h,cftol9	
	ret

cftol9:	lcall	cftolx
	mov	a,cfprim+st67	
	lcall	cftola
	mov	a,cfprim+expo
	cjne	a,#87h,cftolb	
	ret

cftolb:	lcall	cftolx
	mov	a,cfprim+st89	
	swap	a
	lcall	cftola
	mov	a,cfprim+expo
	cjne	a,#88h,cftolc	
	ret

cftolc:	lcall	cftolx
	mov	a,cfprim+st89	
	lcall	cftola
	mov	a,cfprim+expo
	cjne	a,#89h,cftold	
	ret

cftold:	lcall	cftolx
	jc	cftole

	mov	a,cfprim+stab	
	swap	a
	lcall	cftola
	jc	cftole

	ret
cftole:
	mov	a,#0ffh
	mov	r0,a
	mov	r1,a
	mov	r2,a
	mov	r3,#07fh	
	ret

cftola:
	anl	a,#0fh
	add	a,r0
	mov	r0,a
	clr	a
	addc	a,r1
	mov	r1,a
	clr	a
	addc	a,r2
	mov	r2,a
	clr	a
	addc	a,r3
	mov	r3,a
	ret

cftolx:
	mov	b,#10
	mov	a,r0
	mul	ab
	mov	r0,a
	mov	a,b
	xch	a,r1

	mov	b,#10
	mul	ab
	add	a,r1
	mov	r1,a
	push	psw
	mov	a,b
	xch	a,r2
	mov	b,#10
	mul	ab

	pop	psw
	addc	a,r2
	mov	r2,a
	push	psw
	mov	a,b
	xch	a,r3
	mov	b,#10
	mul	ab

	jnb	0D2H,cftlx1	
	pop	psw
	setb	c
	ret

cftlx1:
	pop	psw
	addc	a,r3
	mov	r3,a
	ret


	TITLE	CRMEM.ASM

	ENTRY CRPUTM,CRSPUTM
	ENTRY CRGETM,CRSGETM
	ENTRY CRPUTL,CRSPUTL
	ENTRY CRGPIND,CRSGPIND
	ENTRY CRGSIND,CRSGSIND
	ENTRY CRPIND,CRSPIND
	ENTRY CRGETL,CRSGETL

	ext	cfoverflow
	ext	spxl:byte
	ext	spxh:byte
	ext	cfprim:byte
	ext	cfsec:byte

CRPUTL:
	MOV	A,spxl
	ADD	A,DPL
	MOV	DPL,A
	MOV	A,spxh
	ADDC	A,DPH
	MOV	DPH,A
	SJMP	CRPUTM

CRPIND:
	MOV	DPL,R4
	MOV	DPH,R5

CRPUTM:
	push	ar0
	push	ar1
	MOV	r0,#cfprim+3
	mov	r1,#cfprim+6	
	lcall	crput
	pop	ar1
	pop	ar0
	ret

CRSPUTL:
	MOV	A,spxl
	ADD	A,DPL
	MOV	DPL,A
	MOV	A,spxh
	ADDC	A,DPH
	MOV	DPH,A
	SJMP	CRSPUTM

CRSPIND:
	MOV	DPL,R0
	MOV	DPH,R1

CRSPUTM:
	push	ar0
	push	ar1
	MOV	r0,#cfsec+3
	mov	r1,#cfsec+6	
	lcall	crput
	pop	ar1
	pop	ar0
	ret

crput:
	mov	a,@r0
	cjne	a,#50h,crput5	
	mov	a,@r1
	anl	a,#0f0h
	jz	crput5
	push	ar0
	dec	r0
	mov	a,@r0
	dec	r0
	orl	a,@r0
	dec	r0
	orl	a,@r0
	pop	ar0
	clr	c
	jz	crput7
	sjmp	crput6
crput5:
	mov	a,@r0
	anl	a,#0f0h
	clr	c
	subb	a,#50h
crput6:
	cpl	c
crput7:
	clr	a
	inc	r0
	ADDC	A,@r0
	da	a
	MOVX	@DPTR,A
	mov	r1,a
	INC	DPTR
	inc	r0
	clr	a
	ADDC	A,@r0
	da	a
	MOVX	@DPTR,A
	orl	a,r1
	mov	r1,a
	INC	DPTR
	inc	r0
	clr	a
	ADDC	A,@r0
	da	a
	MOVX	@DPTR,A
	cjne	a,#10h,crput0	

	sjmp	crput2

crput0:
	cjne	a,#90h,crput1	

	mov	a,r1
	jnz	crput1

	mov	a,#99h
	movx	@dptr,a
	inc	dptr
	inc	r0
	MOV	A,@r0
	add	a,#1
	movx	@dptr,a
	jc	crput4
	ret

crput1:
	INC	DPTR
	inc	r0
	MOV	A,@r0
	MOVX	@DPTR,A
	RET

crput2:
	mov	a,#01h
	MOVX	@DPTR,A
	INC	DPTR
	inc	r0
	mov	a,@r0
	add	a,#1
	movx	@dptr,a
	jc	crput3
	ret

crput3:
	mov	a,#0ffh
	movx	@dptr,a

	clr	c
	mov	a,dpl
	subb	a,#3
	mov	dpl,a
	mov	a,dph
	subb	a,#0
	mov	dph,a

	mov	a,#99h
	movx	@dptr,a
	inc	dptr
	movx	@dptr,a
	inc	dptr
	mov	a,#09h
	movx	@dptr,a
	ljmp	cfoverflow	

crput4:
	mov	a,#0ffh
	movx	@dptr,a

	clr	c
	mov	a,dpl
	subb	a,#3
	mov	dpl,a
	mov	a,dph
	subb	a,#0
	mov	dph,a

	mov	a,#01h
	movx	@dptr,a
	inc	dptr
	clr	a
	movx	@dptr,a
	inc	dptr
	mov	a,#90h
	movx	@dptr,a
	ljmp	cfoverflow	

CRGSIND:
	MOV	DPL,R4
	MOV	DPH,R5
	SJMP	CRGETM

CRGETL:
	MOV	A,spxl
	ADD	A,DPL
	MOV	DPL,A
	MOV	A,spxh
	ADDC	A,DPH
	MOV	DPH,A
	SJMP	CRGETM

CRGPIND:
	MOV	DPL,R0
	MOV	DPH,R1

CRGETM:
	CLR	A
	MOV	cfprim,A
	MOV	cfprim+1,A
	MOV	cfprim+2,A
	MOV	cfprim+3,A
	MOVX	A,@DPTR
	MOV	cfprim+4,A
	INC	DPTR
	MOVX	A,@DPTR
	MOV	cfprim+5,A
	INC	DPTR
	MOVX	A,@DPTR
	MOV	cfprim+6,A
	INC	DPTR
	MOVX	A,@DPTR
	MOV	cfprim+7,A
	RET

CRSGSIND:
	MOV	DPL,R4
	MOV	DPH,R5
	SJMP	CRSGETM

CRSGETL:
	MOV	A,spxl
	ADD	A,DPL
	MOV	DPL,A
	MOV	A,spxh
	ADDC	A,DPH
	MOV	DPH,A
	SJMP	CRSGETM

CRSGPIND:
	MOV	DPL,R0
	MOV	DPH,R1

CRSGETM:
	CLR	A
	MOV	cfsec,A
	MOV	cfsec+1,A
	MOV	cfsec+2,A
	MOV	cfsec+3,A
	MOVX	A,@DPTR
	MOV	cfsec+4,A
	INC	DPTR
	MOVX	A,@DPTR
	MOV	cfsec+5,A
	INC	DPTR
	MOVX	A,@DPTR
	MOV	cfsec+6,A
	INC	DPTR
	MOVX	A,@DPTR
	MOV	cfsec+7,A
	RET
	end

	TITLE	CFMEM.ASM

	ENTRY CFPUTM,CFSPUTM
	ENTRY CFGETM,CFSGETM
	ENTRY CFPUTL,CFSPUTL
	ENTRY CFGDIR,CFSGDIR
	ENTRY CFGPIND,CFSGPIND
	ENTRY CFGSIND,CFSGSIND
	ENTRY CFPIND,CFSPIND
	ENTRY CFGETL,CFSGETL

	ext	spxl:byte
	ext	spxh:byte
	ext	cfprim:byte
	ext	cfsec:byte

CFPUTL:
	MOV	A,spxl
	ADD	A,DPL
	MOV	DPL,A
	MOV	A,spxh
	ADDC	A,DPH
	MOV	DPH,A
	SJMP	CFPUTM

CFPIND:
	MOV	DPL,R4
	MOV	DPH,R5

CFPUTM:
	MOV	A,cfprim
	MOVX	@DPTR,A
	INC	DPTR
	MOV	A,cfprim+1
	MOVX	@DPTR,A
	INC	DPTR
	MOV	A,cfprim+2
	MOVX	@DPTR,A
	INC	DPTR
	MOV	A,cfprim+3
	MOVX	@DPTR,A
	INC	DPTR
	MOV	A,cfprim+4
	MOVX	@DPTR,A
	INC	DPTR
	MOV	A,cfprim+5
	MOVX	@DPTR,A
	INC	DPTR
	MOV	A,cfprim+6
	MOVX	@DPTR,A
	INC	DPTR
	MOV	A,cfprim+7
	MOVX	@DPTR,A
	RET

CFSPUTL:
	MOV	A,spxl
	ADD	A,DPL
	MOV	DPL,A
	MOV	A,spxh
	ADDC	A,DPH
	MOV	DPH,A
	SJMP	CFSPUTM

CFSPIND:
	MOV	DPL,R0
	MOV	DPH,R1

CFSPUTM:
	MOV	A,cfsec
	MOVX	@DPTR,A
	INC	DPTR
	MOV	A,cfsec+1
	MOVX	@DPTR,A
	INC	DPTR
	MOV	A,cfsec+2
	MOVX	@DPTR,A
	INC	DPTR
	MOV	A,cfsec+3
	MOVX	@DPTR,A
	INC	DPTR
	MOV	A,cfsec+4
	MOVX	@DPTR,A
	INC	DPTR
	MOV	A,cfsec+5
	MOVX	@DPTR,A
	INC	DPTR
	MOV	A,cfsec+6
	MOVX	@DPTR,A
	INC	DPTR
	MOV	A,cfsec+7
	MOVX	@DPTR,A
	RET

CFGSIND:
	MOV	DPL,R4
	MOV	DPH,R5
	SJMP	CFGETM

CFGETL:
	MOV	A,spxl
	ADD	A,DPL
	MOV	DPL,A
	MOV	A,spxh
	ADDC	A,DPH
	MOV	DPH,A
	SJMP	CFGETM

CFGPIND:
	MOV	DPL,R0
	MOV	DPH,R1

	if	1
CFGDIR:
	endif
CFGETM:
	MOVX	A,@DPTR
	MOV	cfprim,A
	INC	DPTR
	MOVX	A,@DPTR
	MOV	cfprim+1,A
	INC	DPTR
	MOVX	A,@DPTR
	MOV	cfprim+2,A
	INC	DPTR
	MOVX	A,@DPTR
	MOV	cfprim+3,A
	INC	DPTR
	MOVX	A,@DPTR
	MOV	cfprim+4,A
	INC	DPTR
	MOVX	A,@DPTR
	MOV	cfprim+5,A
	INC	DPTR
	MOVX	A,@DPTR
	MOV	cfprim+6,A
	INC	DPTR
	MOVX	A,@DPTR
	MOV	cfprim+7,A
	RET

CFSGSIND:
	MOV	DPL,R4
	MOV	DPH,R5
	SJMP	CFSGETM

CFSGETL:
	MOV	A,spxl
	ADD	A,DPL
	MOV	DPL,A
	MOV	A,spxh
	ADDC	A,DPH
	MOV	DPH,A
	SJMP	CFSGETM

CFSGPIND:
	MOV	DPL,R0
	MOV	DPH,R1

	if	1
CFSGDIR:
	endif
CFSGETM:
	MOVX	A,@DPTR
	MOV	cfsec,A
	INC	DPTR
	MOVX	A,@DPTR
	MOV	cfsec+1,A
	INC	DPTR
	MOVX	A,@DPTR
	MOV	cfsec+2,A
	INC	DPTR
	MOVX	A,@DPTR
	MOV	cfsec+3,A
	INC	DPTR
	MOVX	A,@DPTR
	MOV	cfsec+4,A
	INC	DPTR
	MOVX	A,@DPTR
	MOV	cfsec+5,A
	INC	DPTR
	MOVX	A,@DPTR
	MOV	cfsec+6,A
	INC	DPTR
	MOVX	A,@DPTR
	MOV	cfsec+7,A
	RET

	if	0

CFGDIR:
	POP	DPH
	POP	DPL
	CLR	A
	MOVC	A,@A+DPTR
	MOV	cfprim,A
	MOV	A,#1
	MOVC	A,@A+DPTR
	MOV	cfprim+1,A
	MOV	A,#2
	MOVC	A,@A+DPTR
	MOV	cfprim+2,A
	MOV	A,#3
	MOVC	A,@A+DPTR
	MOV	cfprim+3,A
	MOV	A,#4
	MOVC	A,@A+DPTR
	MOV	cfprim+4,A
	MOV	A,#5
	MOVC	A,@A+DPTR
	MOV	cfprim+5,A
	MOV	A,#6
	MOVC	A,@A+DPTR
	MOV	cfprim+6,A
	MOV	A,#7
	MOVC	A,@A+DPTR
	MOV	cfprim+7,A
	MOV	A,#8
	JMP	@A+DPTR

CFSGDIR:
	POP	DPH
	POP	DPL
	CLR	A
	MOVC	A,@A+DPTR
	MOV	cfsec,A
	MOV	A,#1
	MOVC	A,@A+DPTR
	MOV	cfsec+1,A
	MOV	A,#2
	MOVC	A,@A+DPTR
	MOV	cfsec+2,A
	MOV	A,#3
	MOVC	A,@A+DPTR
	MOV	cfsec+3,A
	MOV	A,#4
	MOVC	A,@A+DPTR
	MOV	cfsec+4,A
	MOV	A,#5
	MOVC	A,@A+DPTR
	MOV	cfsec+5,A
	MOV	A,#6
	MOVC	A,@A+DPTR
	MOV	cfsec+6,A
	MOV	A,#7
	MOVC	A,@A+DPTR
	MOV	cfsec+7,A
	MOV	A,#8
	JMP	@A+DPTR
	endif

	TITLE	CFMDIV.ASM

VORZEI	EQU	6
EXPO	EQU	7
NMANT	EQU	7	
RMANT	EQU	16	

 ENTRY CFMULT,CFDIV,CFSDIV
 EXT CFSWAP,CFNEG,CFSNEG,CF0DIV,CFUNDERFLOW,CFOVERFLOW
 EXT CFSHL
 EXT CFPRIM : byte
 EXT CFSEC  : byte

 EXT CFSTMAX

CFSDIV:
	LCALL	CFSWAP
	SJMP	CFDIV

CFDIV:
	mov	a,CFPRIM+EXPO

	JNZ	cfdv0	
	ljmp	CF0DIV	


cfdv0:
	mov	a,CFSEC+EXPO

	JNZ	CFDV1	

	mov	CFPRIM+EXPO,a
	RET

CFDV1:

	push	ar0
	push	ar1
	push	ar2
	push	ar3
	push	ar4
	push	ar5
	push	ar6
	push	ar7

	mov	a,sp
	inc	a
	mov	r7,a
	add	a,#RMANT-1
	mov	sp,a

	LCALL	CFMDVORZ	


	LCALL	CFDCOMPAR
	mov	A,#81H
	PUSH	acc
	JC	CFDV2	


	POP	acc
	DEC	A
	PUSH	acc	

	mov	r0,#CFSEC+VORZEI
	mov	r1,#1	
	LCALL	CFSHL1	

CFDV2:

	mov	A,#NMANT 
	PUSH	acc	



	mov	a,r7
	add	a,#RMANT-1
	mov	r0,A

	mov	ar4,r0	
	mov	@r0,#0	


CFDVMLOP:
CFDVM1:

	LCALL	CFDCOMPAR
	JNC	CFDVM2	



	LCALL	CFDSUB	

	mov	r0,ar4	
	INC	@r0	

	SJMP	CFDVM1	

CFDVM2:
	mov	r0,#CFSEC+VORZEI
	mov	r1,#1	
	LCALL	CFSHL1	


	mov	r0,ar4
	DEC	r0	
	dec	r4
	mov	@r0,#0	


CFDVM3:

	LCALL	CFDCOMPAR
	JNC	CFDVM4	



	LCALL	CFDSUB	

	mov	r0,ar4	
	mov	A,#10H
	ADD	a,@r0	
	MOV	@r0,A

	SJMP	CFDVM3	

CFDVM4:
	POP	acc	
	DEC	A
	JZ	CFDVMEND	

	PUSH	acc	

	mov	r0,#CFSEC+VORZEI
	mov	r1,#1	
	LCALL	CFSHL1	

	SJMP	CFDVMLOP

CFDVMEND:

	mov	a,r7
	ADD	a,#(rmant-nmant-1)
	mov	r0,a

	mov	r1,#CFPRIM
	mov	r2,#NMANT 
	MOV	A,@r0
	INC	r0
	clr	c	
	subb	a,#50H	
	cpl	c	
	JNC	CFDV4	

CFDV5:

	clr	A
	ADDC	a,@r0
	DA	A
	mov	@r1,A
	INC	r0
	INC	r1
	DEC	r2
	JC	CFDV5	

	mov	a,r2
	JZ	CFDV42	

CFDV4:

	MOV	A,@r0
	mov	@r1,a
	INC	r0
	INC	r1
	DEC	r2
	mov	a,r2
	JNZ	CFDV4

CFDV41:
	mov	a,r0
	xch	a,r1
	mov	r0,a

	MOV	A,@r0
	cpl	a
	inc	a	
	MOV	@r0,A	

	POP	acc	
	LJMP	CFMDKX	

CFDV42:
	DEC	r1
	mov	a,@r1
	clr	c
	subb	a,#10H
	INC	r1
	JNZ	CFDV41	

	mov	a,r0
	xch	a,r1
	mov	r0,a
	DEC	r0
	mov	@r0,#1
	INC	r0

	MOV	A,@r0	
	cpl	a
	inc	A
	MOV	@r0,A

	POP	acc	
	inc	A	
	LJMP	CFMDKX

CFDSUB:
	mov	r1,#CFSEC
	mov	r0,#CFPRIM
	mov	r2,#NMANT	

cfds1:
	clr	c
	mov	A,#99H
	SUBB	a,@r0
	MOV	B,A
	mov	a,@r1
	setb	c
	ADDC	A,B
	DA	A
	mov	@r1,a
	INC	r0
	INC	r1
	DEC	r2
	mov	a,r2
	jz	cfds3	
	JC	CFDS1

CFDS2:
	mov	A,#99H
	SUBB	a,@r0
	MOV	B,A
	mov	a,@r1
	ADD	a,b
	DA	A
	mov	@r1,a
	INC	r0
	INC	r1
	DEC	r2
	mov	a,r2
	jz	cfds3	
	JNC	CFDS2
	SJMP	CFDS1

cfds3:
	RET

CFDCOMPAR:
	mov	r0,#CFSEC+VORZEI	
	mov	r1,#CFPRIM+VORZEI
	mov	r2,#7
	clr	c

CFDC1:

	mov	a,@r1
	subb	a,@r0	
	jc	cfdc2	

	jnz	cfdc2	

	DEC	r0
	DEC	r1
	DEC	r2
	mov	a,r2
	JNZ	CFDC1

	setb	c	
cfdc2:
	RET

CFMULT:

	mov	a,cfprim+expo
	jnz	cfmul1
	ret

cfmul1:
	mov	a,cfsec+expo
	jnz	cfmul2
	mov	cfprim+expo,a	
	ret

cfmul2:
	push	ar0
	push	ar1
	push	ar2
	push	ar3
	push	ar4
	push	ar5
	push	ar6
	push	ar7
	mov	a,sp
	inc	a
	mov	r7,a
	add	a,#RMANT-1
	mov	sp,a
	LCALL	CFMDVORZ	


	mov	r1,#rmant	
	mov	r0,ar7

	clr	a
cfmul3:
	mov	@r0,a
	inc	r0
	djnz	r1,cfmul3	

	mov	r0,#cfprim	
	mov	r2,#nmant-1	

	mov	r5,#0

cfmul4:
	mov	a,@r0
	lcall	cfmlz

	mov	a,@r0
	swap	a
	inc	r5
	lcall	cfmlz

	inc	r5
	inc	r0
	djnz	r2,cfmul4	
	mov	a,@r0
	lcall	cfmlz

	mov	a,r7
	ADD	a,#12
	mov	r0,a
	mov	a,@r0

	anl	a,#0f0h
	JNZ	CFMUL5

	clr	c
	mov	a,r7
	ADD	a,#5
	mov	r0,a

	mov	r1,#cfprim
	mov	r2,#nmant

	mov	a,@r0
	subb	a,#50h
	cpl	c
	inc	r0
	jnc	cfmul6

cfmul7:
	clr	a
	addc	a,@r0
	da	a
	mov	@r1,a
	inc	r0
	inc	r1
	dec	r2
	jc	cfmul7
	mov	a,r2
	jz	cfmul8

cfmul6:
	mov	a,@r0
	mov	@r1,a
	inc	r0
	inc	r1
	djnz	r2,cfmul6

CFMUL8:
	mov	r0,#cfprim+vorzei
	mov	a,@r0
	inc	r0
	anl	a,#0f0h
	jnz	cfmul81
	mov	a,#7fh
	sjmp	cfmdkx

cfmul81:
	dec	r0
	mov	@r0,#01h
	inc	r0
	mov	a,#80h
	sjmp	cfmdkx

CFMUL5:
	mov	a,r7
	ADD	a,#6
	mov	r0,a

	mov	r1,#cfprim	
	mov	r2,#nmant	

	mov	a,@r0
	anl	a,#0fh
	clr	c
	subb	a,#05h
	cpl	c
	jnc	cfmul10

cfmul9:
	mov	a,@r0
	anl	a,#0f0h
	inc	r0
	xchd	a,@r0
	swap	a

	addc	a,#0
	da	a
	mov	@r1,a
	inc	r1
	dec	r2
	jc	cfmul9
	mov	a,r2
	jz	cfmul11

cfmul10:
	mov	a,@r0
	anl	a,#0f0h
	inc	r0
	xchd	a,@r0
	swap	a
	mov	@r1,a
	inc	r1
	djnz	r2,cfmul10	

cfmul11:
	mov	r0,#cfprim+vorzei 
	mov	a,@r0
	anl	a,#0f0h
	jnz	cfmul12

	mov	a,#80h
	inc	r0
	sjmp	cfmdkx

cfmul12:
	mov	@r0,#01h
	mov	a,#80h
	inc	r0

CFMDKX:
	add	a,@r0

	mov	b,a
	mov	a,cfsec+expo	
	jc	cfmdk1
	add	a,b
	mov	@r0,a
	jc	cfmdk2

	lcall	cfunderflow	
	sjmp	cfmuln

cfmdk1:
	add	a,b
	mov	@r0,a
	jnc	cfmdk2

	lcall	cfoverflow	
	lcall	cfstmax	

cfmdk2:
	mov	a,r3
	jz	cfmuln

	lcall	cfneg

cfmuln:
	dec	r7
	mov	sp,r7
	pop	ar7
	pop	ar6
	pop	ar5
	pop	ar4
	pop	ar3
	pop	ar2
	pop	ar1
	pop	ar0	
	ret

CFMDVORZ:
	mov	r0,#cfprim+vorzei
	mov	r1,#cfsec+vorzei
	mov	a,@r1
	xrl	a,@r0
	anl	a,#0f0h
	mov	r3,a

	mov	a,@r0
	anl	a,#0f0h
	jz	cfmdvz1
	lcall	cfneg
cfmdvz1:
	mov	a,@r1
	anl	a,#0f0h
	jz	cfmdvz2
	lcall	cfsneg
cfmdvz2:
	ret

cfmlz:
	push	ar0	
	push	ar2
	anl	a,#0fh	
	mov	r4,a	
	mov	r0,#cfsec 
	mov	r6,#nmant-1 

	clr	c
	mov	a,r5	
	rrc	a	
	mov	f0,c	
	mov	r1,ar7 

	add	a,r1	
	mov	r1,a	

cfmlz1:
	mov	a,@r0	
	lcall	cfmbcd	
	mov	a,@r0	
	swap	a	
	lcall	cfmbcd	
	inc	r0	
	djnz	r6,cfmlz1 

	mov	a,@r0	
	lcall	cfmbcd	

	pop	ar2
	pop	ar0	
	ret

cfmbcd:
	anl	a,#0fh	
	jz	cfmbcd6	
	mov	r2,a
	mov	a,r4	
	jz	cfmbcd6	
	mov	b,a	
	clr	a	
cfmbcd7:
	add	a,r2	
	da	a	
	djnz	b,cfmbcd7
cfmbcd6:
	jbc	f0,cfmbcd1 

	add	a,@r1	
	da	a	
	mov	@r1,a	
	jnc	cfmbcd2	

	push	ar1	
cfmbcd3:
	inc	r1	
	clr	a
	addc	a,@r1	
	da	a
	mov	@r1,a	
	jc	cfmbcd3	
	pop	ar1	
cfmbcd2:
	setb	f0	
	ret

cfmbcd1:
	swap	a	
	mov	r2,a	
	anl	a,#0f0h	
	add	a,@r1	
	da	a
	mov	@r1,a
	inc	r1	
	mov	a,r2
	anl	a,#0fh	
	addc	a,@r1	
	da	a
	mov	@r1,a
	jnc	cfmbcd4	

	push	ar1	
cfmbcd5:
	inc	r1	
	clr	a
	addc	a,@r1	
	da	a
	mov	@r1,a	
	jc	cfmbcd5	
	pop	ar1	
cfmbcd4:
	ret

cfshl1:
	mov	a,@r0	
	push	acc	
	lcall	cfshl	
	pop	acc	
	swap	a	
	xchd	a,@r0	
	mov	@r0,a	
	ret
	TITLE	CFADD.ASM

 entry	cfadd,cfsub,cfssub,cfnorm,cfshl
 ext 	cfneg,cfsneg
 ext	cfoverflow,cfunderflow,cfstmax,cfstmin
 ext	cfprim:byte
 ext	cfsec :byte

VORZEI	EQU	6
EXPO	EQU	7
NMANT	EQU	7	

cfssub:
	lcall	cfsneg
	sjmp	cfadd

cfsub:
	lcall	cfneg

cfadd:
	push	ar0
	push	ar1
	push	ar2
	push	ar3
	mov	a,cfsec+expo
	jz	cfadn
	mov	a,cfprim+expo
	jz	cfadsnp

	clr	c
	subb	a,cfsec+expo	
	jnc	cfad1fall	

	clr	c
	mov	r2,a
	subb	a,#-13
	jc	cfadsnp
	mov	r3,cfprim+vorzei
	anl	ar3,#0f0h	
	clr	a
	subb	a,r2
	mov	r2,a

	mov	r0,#cfsec	
	mov	r1,#cfprim	
	lcall	cfaddition	
	sjmp	cfadsnp

cfad1fall:	
	mov	r2,a
	subb	a,#14
	jnc	cfadn
	mov	r3,cfsec+vorzei
	anl	ar3,#0f0h	

	mov	a,r2
	mov	r0,#cfprim	
	mov	r1,#cfsec	
	lcall	cfaddition	

cfadn:
	pop	ar3
	pop	ar2
	pop	ar1
	pop	ar0
	ret

cfaddition:
	clr	c	
	jnz	cfadd4	
	mov	r3,#50h	

	sjmp	cfadd6	
cfadd4:
	rrc	a	

	push	psw	
	cpl	c
	subb	a,#0	


	mov	r2,a	
	mov	a,r3	
	jz	cfadd0	

	mov	a,r2	
	jz	cfadd2	
	mov	b,a	
	clr	a	
cfadd3:
	orl	a,@r1	
	inc	r1
	djnz	b,cfadd3

	mov	r3,#50h	
	jnz	cfadd1	
cfadd2:
	mov	r3,#40h	
	sjmp	cfadd1	

cfadd0:

	mov	a,r2	
	add	a,r1	
	mov	r1,a	
	mov	r3,#50h	

cfadd1:
	pop	psw	
	jc	cfad21	

	inc	r2	

cfadd6:
	lcall	cfadgrazi 
	dec	r0	
	sjmp	cfadnor	

cfad21:
	lcall	cfadungr 
	dec	r0	
	sjmp	cfadnor	

cfadsnp:	
	mov	cfprim+0,cfsec+0
	mov	cfprim+1,cfsec+1
	mov	cfprim+2,cfsec+2
	mov	cfprim+3,cfsec+3
	mov	cfprim+4,cfsec+4
	mov	cfprim+5,cfsec+5
	mov	cfprim+6,cfsec+6
	mov	cfprim+7,cfsec+7
	pop	ar3
	pop	ar2
	pop	ar1
	pop	ar0
	ret

cfadnor:
	mov	a,@r0	
	anl	a,#0f0h
	clr	c
	subb	a,#10h	
	jnz	cfad1nor
	ljmp	cfad30	
cfad1nor:
	subb	a,#70h	
	jnz	cfad2nor
	ljmp	cfad30	
cfad2nor:
	inc	r0	
	ljmp	cfnorm	

cfadgrazi:
	mov	a,r2
	push	ar2
	jz	cfadg0

	mov	a,#nmant	
	subb	a,r2
	mov	r2,a
	mov	a,@r1
	inc	r1
	add	a,r3
	da	a
	sjmp	cfadg1

cfadg0:
	mov	r2,#nmant	
cfadg1:
	mov	a,@r1
	addc	a,@r0

	da	a
	mov	@r0,a
	inc	r1
	inc	r0
	djnz	r2,cfadg1	

	push	psw
	dec	r1
	mov	a,@r1
	anl	a,#0f0h	
	mov	r3,a
	cjne	a,#90h,cfadg2	
	mov	r3,#99h
cfadg2:
	pop	psw
	pop	ar2
	mov	a,r2
	jz	cfadg4
cfadg3:
	mov	a,r3
	addc	a,@r0
	da	a
	mov	@r0,a
	inc	r0
	djnz	r2,cfadg3	
cfadg4:
	ret

cfadungr:

	mov	a,@r1
	swap	a
	add	a,r3
	da	a

	push	ar2
	push 	psw
	clr	c

	mov	a,#nmant-1	
	subb	a,r2
	mov	r2,a
	pop	psw
	jz	cfadug1

cfadug0:
	mov	a,@r1

	inc	r1
	xchd	a,@r1
	swap	a
	addc	a,@r0
	da	a
	mov	@r0,a
	inc	r0
	djnz	r2,cfadug0	
cfadug1:
	pop	ar2
	push	psw
	mov	a,@r1
	anl	a,#0f0h
	mov	r3,a
	cjne	a,#90h,cfadug2	
	mov	r3,#99h
cfadug2:
	pop	psw
	inc	r2
cfadug3:
	mov	a,r3
	addc	a,@r0
	da	a
	mov	@r0,a
	inc	r0
	djnz	r2,cfadug3	

	ret

cfad30:
	mov	r2,#nmant-1	
	mov	a,r0
	clr	c
	subb	a,#vorzei	
	mov	r0,a
	mov	r1,a
	clr	a
	xchd	a,@r0
	subb	a,#05
	jc	cfad33
cfad31:
	mov	a,@r0
	inc	r0
	xchd	a,@r0
	swap	a
	add	a,#01
	da	a
	mov	@r1,a
	inc	r1
	djnz	r2,cfad32
	sjmp	cfad34
cfad32:	jc	cfad31

cfad33:
	clr	c
	mov	a,@r0
	inc	r0
	xchd	a,@r0
	swap	a
	mov	@r1,a
	inc	r1
	djnz	r2,cfad33

cfad34:
	push	psw
	mov	a,@r0
	anl	a,#0f0h
	swap	a
	mov	r2,a
	cjne	a,#8,cfad35	
	add	a,#90h
cfad35:	pop	psw
	addc	a,#0
	mov	@r0,a
	inc	r0
	inc	@r0
	mov	a,@r0
	jnz	cfad36
	lcall	cfoverflow	
	cjne	r2,#1,cfad37	
	ljmp	cfstmax	
cfad37:	ljmp	cfstmin	
cfad36:	ret

cfnorm:
	push	ar1	
	mov	a,@r0	
	jz	cfnon	
	dec	r0	
	mov	a,@r0	
	anl	a,#0f0h	
	jnz	cfnoneg	

	mov	a,@r0	
	anl	a,#0fh	
	jnz	cfnon	
	push	ar0	
	mov	r1,#nmant+nmant-2 
	dec	r0	
cfno1:
	cjne	@r0,#0,cfno2	
	dec	r0	
	dec	r1	
	djnz	r1,cfno1

	pop	ar0	
	inc	r0	
	mov	@r0,#0	
cfnon:
	pop	ar1	
	ret

cfno2:
	mov	a,@r0	
	anl	a,#0f0h	
	jnz	cfno4	
	dec	r1	
cfno4:
	mov	a,#nmant+nmant-1 
	clr	c	
	subb	a,r1	
	mov	r1,a	
	po	ar
	inc	r0	
	mov	a,@r0	
	subb	a,r1	
	jc	cfno3	
	jz	cfno3	
	mov	@r0,a	
	dec	r0	
	lcall	cfshl	
	sjmp	cfnon	

cfno3:
	mov	@r0,#0	
	POP	ar1	
	ljmp	cfunderflow 

cfnoneg:
	cjne	@r0,#99h,cfnong1	

	push	ar0
	mov	r1,#nmant+nmant-2	
	dec	r0
cfnong2:
	cjne	@r0,#99h,cfnong3	
	dec	r0
	dec	r1
	djnz	r1,cfnong2	

	sjmp	cfnong4

cfnong3:
	mov	b,r1
	mov	a,@r0
	anl	a,#90h
	cjne	a,#90h,cfnong5	
	dec	r1
	cjne	@r0,#90h,cfnong6	
	dec	b
	dec	b
	dec	r0
cfnong5:
	mov	a,b
	jz	cfnong4
cfnong7:
	cjne	@r0,#0,cfnong6	
	dec	r0
	dec	b
	djnz	b,cfnong7	
cfnong4:
	inc	r1
cfnong6:
	sjmp	cfno4

cfnong1:
	cjne	@r0,#90h,cfnon	
	push	ar0
	mov	r1,#nmant - 1	
	dec	r0
cfnong9:
	cjne	@r0,#0,cfnong8	
	dec	r0
	djnz	r1,cfnong9	

	pop	ar0
	mov	@r0,#99h	
	inc	r0
	inc	@r0
	mov	a,@r0
	jnz	cfnon
	lcall	cfstmin	
	pop	ar1
	ljmp	cfoverflow	

cfnong8:
	pop	ar0
	sjmp	cfnon	

cfshl:
	mov	a,@r0	
	anl	a,#0f0h	
	push	ar0	
	push	acc	
	mov	a,r1	
	jz	cfshln	
	clr	c
	rrc	a	
	push	acc	
	mov	b,a	
	mov	ar1,r0
	xch	a,r1
	jc	cfshlu	
	subb	a,r1	
	mov	r1,a	
	mov	a,#nmant
	subb	a,b	
	mov	b,a	
cfshl1:
	mov	a,@r1	
	mov	@r0,a	
	dec	r0
	dec	r1	
	djnz	b,cfshl1
	pop	b	
cfshl4:
	clr	a	
cfshl2:
	mov	@r0,a	
	dec	r0	
	djnz	b,cfshl2
	sjmp	cfshln	

cfshlu:	
	subb	a,r1	
	mov	r1,a	
	mov	a,#nmant-1
	subb	a,b	
	mov	b,a	
cfshl3:
	mov	a,@r1	
	swap	a	
	xchd	a,@r0	
	dec	r0	
	xchd	a,@r1	
	swap	a	
	mov	@r0,a	
	dec	r1	
	djnz	b,cfshl3
 	clr	a
	xchd	a,@r0	
	pop	acc	
	mov	b,a	
	dec	r0	
	jnz	cfshl4	
cfshln:
	pop	acc	
	pop	ar0	
	xchd	a,@r0	
	mov	@r0,a	
	ret
	TITLE	CFINC.ASM

 entry	cfinc,cfsinc,cfdec,cfsdec
 ext 	cfadd,cfpush,cfpop,cfspush,cfspop,cfswap
 ext	cfprim:byte
 ext	cfsec :byte

VORZEI	EQU	6
EXPO	EQU	7
NMANT	EQU	7	

cfinc:	push	ar0
	push	ar1
	mov	a,cfprim+expo
	jnz	cfin1
	mov	r0,#cfprim
	mov	b,#1
	lcall	cfxnul
	pop	ar1
	pop	ar0
	ret

cfin1:	lcall	cfspush	
	mov	r0,#cfsec	
	mov	b,#1
	lcall	cfxnul
	lcall	cfadd
	lcall	cfspop
	pop	ar1
	pop	ar0
	ret

cfsinc:push	ar0
	push	ar1
	mov	a,cfsec+expo
	jnz	cfsin1
	mov	r0,#cfsec
	mov	b,#1
	lcall	cfxnul
	pop	ar1
	pop	ar0
	ret

cfsin1:	lcall	cfpush
	mov	r0,#cfprim	
	mov	b,#1
	lcall	cfxnul
	lcall	cfadd
	lcall	cfswap
	lcall	cfpop
	pop	ar1
	pop	ar0
	ret

cfdec:	push	ar0
	push	ar1
	mov	a,cfprim+expo
	jnz	cfde1
	mov	r0,#cfprim
	mov	b,#99h
	lcall	cfxnul
	pop	ar1
	pop	ar0
	ret

cfde1:	lcall	cfspush	
	mov	r0,#cfsec	
	mov	b,#99h
	lcall	cfxnul
	lcall	cfadd
	lcall	cfspop
	pop	ar1
	pop	ar0
	ret

cfsdec:	push	ar0
	push	ar1
	mov	a,cfsec+expo
	jnz	cfsde1
	mov	r0,#cfsec
	mov	b,#99h
	lcall	cfxnul
	pop	ar1
	pop	ar0
	ret

cfsde1:	lcall	cfpush
	mov	r0,#cfprim	
	mov	b,#99h
	lcall	cfxnul
	lcall	cfadd
	lcall	cfswap
	lcall	cfpop
	pop	ar1
	pop	ar0
	ret

cfxnul:	clr	a
	mov	r1,#6
cfxnu1:	mov	@r0,a
	inc	r0
	djnz	r1,cfxnu1
	mov	@r0,b
	inc	r0
	mov	@r0,#81h	
	ret
	TITLE	CFVGL.ASM

 ENTRY CFEQ,CFNE,CFGT,CFLE,CFGE,CFLT,CFSWTEST
 EXT CFPRIM : byte
 EXT CFSEC  : byte

VORZEI	EQU	6
EXPO	EQU	7
NMANT	EQU	7	

CFEQ:	
	lcall	CFCMP
	mov	r1,#0
	jz	cfeq1
cfeq0:	clr	a
	mov	r0,a
	ret
cfeq1:	mov	a,#1
	mov	r0,a
	ret

CFNE:	
	LCALL	CFCMP
	mov	r1,#0
	jnz	cfeq1
	mov	r1,a
	mov	r0,a
	ret

CFGT:
	LCALL CFCMP
	mov	r1,#0
	jz	cfeq0
	jc	cfeq0

	mov	a,#1
	mov	r0,a
	ret

CFLE:	
	LCALL CFCMP
	mov	r1,#0
	jz	cfeq1
	jc	cfeq1

	clr	a
	mov	r0,a
	ret

CFGE:
	LCALL CFCMP
	mov	r1,#0
	jz	cfeq1
	jnc	cfeq1

	clr	a
	mov	r0,a
	ret

CFLT:
	LCALL CFCMP
	mov	r1,#0
	jz	cfeq0
	jnc	cfeq0

	mov	a,#1
	mov	r0,a
	ret

CFSWTEST:

CFCMP:
	push	ar0
	push	ar1
	mov	r0,#CFSEC+VORZEI
	mov	r1,#CFPRIM+VORZEI
	mov	a,@r0
	anl	a,#0f0h
	mov	b,a
	mov	a,@r1
	anl	a,#0f0h
	clr	c
	subb	a,b
	jz	CFCVGLEI	

	jc	CFCVPKG
	inc	r1
	mov	a,@r1

	jnz	CFCMPN

	inc	r0
	MOV	A,@r0
	jz	CFCMPN



CFCVPKG:
	inc	r1
	mov	a,@r1

	jnz	CFCMPN

	inc	r0
	mov	a,@r0
	clr	c
	jz	CFCMPN

	setb	c
	sjmp	CFCMPN

CFCVGLEI:
	inc	r1
	inc	r0
	mov	a,@r1
	subb	a,@r0
	jz	CF7CMP

	mov	a,b
	JNC	CF8CMP

	JNZ	CF9CMP
	inc	a
	clr	c
	sjmp	CFCMPN

CF9CMP:
	setb	c
	sjmp	CFCMPN

CF8CMP:

	jnz	CFCMPN

	inc	a
	setb	c
	sjmp	CFCMPN

CF7CMP:
	mov	a,@r0
	jz	CFCMPN

	mov	b,#7
CF10CMP:
	dec	r0
	dec	r1
	mov	a,@r1
	subb	a,@r0
	jnz	CF11CMP
	djnz	b,CF10CMP
	sjmp	CFCMPN

CF11CMP:
	cpl	c


CFCMPN:
	pop	ar1
	pop	ar0
	ret

	TITLE	CFTEST

expo	equ	7

	public	cfpush,cfpop,cfspush,cfspop
	public	cflnot,cfslnot
	public	cfsflag,cfssflag
	ext	spxl:byte
	ext	spxh:byte
	ext	cfprim:byte
	ext	cfsec:byte

cfsflag:
	mov	a,cfprim+expo
	ret

cfssflag:
	mov	a,cfsec+expo
	ret

cflnot:
	mov	a,cfprim+expo
	mov	r0,#1
	mov	r1,#0
	JZ	CFLN1
	dec	r0
	mov	a,r0
	RET
CFLN1:
	mov	a,r0
	RET

cfslnot:
	mov	a,cfsec+expo
	mov	r4,#1
	mov	r5,#0
	JZ	CFSLN1
	dec	r4
	mov	a,r4
	RET
CFSLN1:
	mov	a,r1
	RET

cfpush:
	mov	a,spxl	
	clr	c	
	subb	a,#8	
	mov	spxl,a	
	mov	dpl,a	
	mov	a,spxh	
	subb	a,#0	
	mov	spxh,a	
	mov	dph,a	
	mov	a,cfprim	
	movx	@dptr,a	
	inc	dptr	
	mov	a,cfprim+1	
	movx	@dptr,a	
	inc	dptr	
	mov	a,cfprim+2	
	movx	@dptr,a	
	inc	dptr	
	mov	a,cfprim+3	
	movx	@dptr,a	
	inc	dptr	
	mov	a,cfprim+4	
	movx	@dptr,a	
	inc	dptr	
	mov	a,cfprim+5	
	movx	@dptr,a	
	inc	dptr	
	mov	a,cfprim+6	
	movx	@dptr,a	
	inc	dptr	
	mov	a,cfprim+7	
	movx	@dptr,a	
	ret

cfpop:
	mov	dpl,spxl
	mov	dph,spxh
	movx	a,@dptr	
	mov	cfprim,a	
	inc	dptr	
	movx	a,@dptr	
	mov	cfprim+1,a	
	inc	dptr	
	movx	a,@dptr	
	mov	cfprim+2,a	
	inc	dptr	
	movx	a,@dptr	
	mov	cfprim+3,a	
	inc	dptr	
	movx	a,@dptr	
	mov	cfprim+4,a	
	inc	dptr	
	movx	a,@dptr	
	mov	cfprim+5,a	
	inc	dptr	
	movx	a,@dptr	
	mov	cfprim+6,a	
	inc	dptr	
	movx	a,@dptr	
	mov	cfprim+7,a	
	inc	dptr	

	mov	spxl,dpl
	mov	spxh,dph
	ret

cfspush:
	mov	a,spxl	
	clr	c	
	subb	a,#8	
	mov	spxl,a	
	mov	dpl,a	
	mov	a,spxh	
	subb	a,#0	
	mov	spxh,a	
	mov	dph,a	
	mov	a,cfsec	
	movx	@dptr,a	
	inc	dptr	
	mov	a,cfsec+1	
	movx	@dptr,a	
	inc	dptr	
	mov	a,cfsec+2	
	movx	@dptr,a	
	inc	dptr	
	mov	a,cfsec+3	
	movx	@dptr,a	
	inc	dptr	
	mov	a,cfsec+4	
	movx	@dptr,a	
	inc	dptr	
	mov	a,cfsec+5	
	movx	@dptr,a	
	inc	dptr	
	mov	a,cfsec+6	
	movx	@dptr,a	
	inc	dptr	
	mov	a,cfsec+7	
	movx	@dptr,a	
	ret

cfspop:
	mov	dpl,spxl
	mov	dph,spxh
	movx	a,@dptr	
	mov	cfsec,a 
	inc	dptr	
	movx	a,@dptr	
	mov	cfsec+1,a
	inc	dptr	
	movx	a,@dptr	
	mov	cfsec+2,a 
	inc	dptr	
	movx	a,@dptr	
	mov	cfsec+3,a
	inc	dptr	
	movx	a,@dptr	
	mov	cfsec+4,a
	inc	dptr	
	movx	a,@dptr	
	mov	cfsec+5,a
	inc	dptr	
	movx	a,@dptr	
	mov	cfsec+6,a
	inc	dptr	
	movx	a,@dptr	
	mov	cfsec+7,a
	inc	dptr	

	mov	spxl,dpl
	mov	spxh,dph
	ret

	TITLE	CFHILF

	public	cfprim,cfsec
	public	cfneg,cfsneg
	public	cfstmin,cfstmax
	public	cfswap

NMANT	EQU	7	

cfsneg:
	push	ar0
	mov	r0,#cfsec
	sjmp	cfne0

cfneg:
	push	ar0
	mov	r0,#cfprim
cfne0:
	mov	b,#nmant	
cfne1:
	clr	c	
	mov	a,#99h	
	subb	a,@r0	
	add	a,#1	
	da	a	
	mov	@r0,a	
	inc	r0	
	dec	b	
	mov	a,b	
	jz	cfne3	
	jc	cfne1	

cfne2:
	mov	a,#99h	
	subb	a,@r0	
	mov	@r0,a	
	inc	r0	
	dec	b	
	mov	a,b	
	jnz	cfne2	
cfne3:
	pop	ar0
	ret

cfstmin:
	push	ar0
	push	ar1
	mov	@r0,#0ffh
	dec	r0	
	mov	@r0,#90h
	mov	r1,#nmant-2
cfstmi1:
	mov	@r0,#0
	dec	r0
	djnz	r1,cfstmi1
	mov	@r0,#1
	pop	ar1
	pop	ar0
	ret

cfstmax:
	push	ar0
	push	ar1
	mov	@r0,#0ffh
	dec	r0
	mov	@r0,#09h
	mov	r1,#nmant-1
cfstma1:
	mov	@r0,#99h	
	dec	r0
	djnz	r1,cfstma1
	pop	ar1
	pop	ar0
	ret


cfswap:
	MOV	A,cfprim
	XCH	A,cfsec
	MOV	cfprim,A
	MOV	A,cfprim+1
	XCH	A,cfsec+1
	MOV	cfprim+1,A
	MOV	A,cfprim+2
	XCH	A,cfsec+2
	MOV	cfprim+2,A
	MOV	A,cfprim+3
	XCH	A,cfsec+3
	MOV	cfprim+3,A
	MOV	A,cfprim+4
	XCH	A,cfsec+4
	MOV	cfprim+4,A
	MOV	A,cfprim+5
	XCH	A,cfsec+5
	MOV	cfprim+5,A
	MOV	A,cfprim+6
	XCH	A,cfsec+6
	MOV	cfprim+6,A
	MOV	A,cfprim+7
	XCH	A,cfsec+7
	MOV	cfprim+7,A
	mov	a,r0
	xch	a,r4
	mov	r0,a
	mov	a,r1
	xch	a,r5
	mov	r1,a
	mov	a,r2
	xch	a,r6
	mov	r2,a
	mov	a,r3
	xch	a,r7
	mov	r3,a
	RET

xxxreg	segment intern

cfprim	ds	8
cfsec	ds	8

	end

